! -*- F90 -*-
BEGIN_PROVIDER [ character*2 , elsymb , (92) ]
BEGIN_DOC
! the symbols of the elements
END_DOC
        ELSYMB( 1) = 'H '
        ELSYMB( 2) = 'He'
        ELSYMB( 3) = 'Li'
        ELSYMB( 4) = 'Be'
        ELSYMB( 5) = 'B '
        ELSYMB( 6) = 'C '
        ELSYMB( 7) = 'N '
        ELSYMB( 8) = 'O '
        ELSYMB( 9) = 'F '
        ELSYMB(10) = 'Ne'
        ELSYMB(11) = 'Na'
        ELSYMB(12) = 'Mg'
        ELSYMB(13) = 'Al'
        ELSYMB(14) = 'Si'
        ELSYMB(15) = 'P '
        ELSYMB(16) = 'S '
        ELSYMB(17) = 'Cl'
        ELSYMB(18) = 'Ar'
        ELSYMB(19) = 'K '
        ELSYMB(20) = 'Ca'
        ELSYMB(21) = 'Sc'
        ELSYMB(22) = 'Ti'
        ELSYMB(23) = 'V '
        ELSYMB(24) = 'Cr'
        ELSYMB(25) = 'Mn'
        ELSYMB(26) = 'Fe'
        ELSYMB(27) = 'Co'
        ELSYMB(28) = 'Ni'
        ELSYMB(29) = 'Cu'
        ELSYMB(30) = 'Zn'
        ELSYMB(31) = 'Ga'
        ELSYMB(32) = 'Ge'
        ELSYMB(33) = 'As'
        ELSYMB(34) = 'Se'
        ELSYMB(35) = 'Br'
        ELSYMB(36) = 'Kr'
        ELSYMB(37) = 'Rb'
        ELSYMB(38) = 'Sr'
        ELSYMB(39) = 'Y '
        ELSYMB(40) = 'Zr'
        ELSYMB(41) = 'Nb'
        ELSYMB(42) = 'Mo'
        ELSYMB(43) = 'Tc'
        ELSYMB(44) = 'Ru'
        ELSYMB(45) = 'Rh'
        ELSYMB(46) = 'Pd'
        ELSYMB(47) = 'Ag'
        ELSYMB(48) = 'Cd'
        ELSYMB(49) = 'In'
        ELSYMB(50) = 'Sn'
        ELSYMB(51) = 'Sb'
        ELSYMB(52) = 'Te'
        ELSYMB(53) = 'I '
        ELSYMB(54) = 'Xe'
        ELSYMB(55) = 'Cs'
        ELSYMB(56) = 'Ba'
        ELSYMB(57) = 'La'
        ELSYMB(58) = 'Ce'
        ELSYMB(59) = 'Pr'
        ELSYMB(60) = 'Nd'
        ELSYMB(61) = 'Pm'
        ELSYMB(62) = 'Sm'
        ELSYMB(63) = 'Eu'
        ELSYMB(64) = 'Gd'
        ELSYMB(65) = 'Tb'
        ELSYMB(66) = 'Dy'
        ELSYMB(67) = 'Ho'
        ELSYMB(68) = 'Er'
        ELSYMB(69) = 'Tm'
        ELSYMB(70) = 'Yb'
        ELSYMB(71) = 'Lu'
        ELSYMB(72) = 'Hf'
        ELSYMB(73) = 'Ta'
        ELSYMB(74) = 'W '
        ELSYMB(75) = 'Re'
        ELSYMB(76) = 'Os'
        ELSYMB(77) = 'Ir'
        ELSYMB(78) = 'Pt'
        ELSYMB(79) = 'Au'
        ELSYMB(80) = 'Hg'
        ELSYMB(81) = 'Tl'
        ELSYMB(82) = 'Pb'
        ELSYMB(83) = 'Bi'
        ELSYMB(84) = 'Po'
        ELSYMB(85) = 'At'
        ELSYMB(86) = 'Rn'
        ELSYMB(87) = 'Fr'
        ELSYMB(88) = 'Ra'
        ELSYMB(89) = 'Ac'
        ELSYMB(90) = 'Th'
        ELSYMB(91) = 'Pa'
        ELSYMB(92) = 'U '
END_PROVIDER 

BEGIN_PROVIDER [ integer, elmass , (92) ]
BEGIN_DOC
! the masses of the elements
END_DOC
        implicit none
        integer :: i

        ELMASS( 1) = 1
        ELMASS( 2) = 4
        ELMASS( 3) = 7
        ELMASS( 4) = 8
        ELMASS( 5) = 11
        ELMASS( 6) = 12
        ELMASS( 7) = 14
        ELMASS( 8) = 16
        ELMASS( 9) = 19
        ELMASS(10) = 20
        ELMASS(11) = 23
        ELMASS(12) = 24
        ELMASS(13) = 27
        ELMASS(14) = 28
        ELMASS(15) = 31
        ELMASS(16) = 32
        ELMASS(17) = 35
        ELMASS(18) = 40
        ELMASS(19) = 39
        ELMASS(20) = 40
        ELMASS(21) = 45
        ELMASS(22) = 48
        ELMASS(23) = 51
        ELMASS(24) = 52
        ELMASS(25) = 55
        ELMASS(26) = 56
        ELMASS(27) = 59
        ELMASS(28) = 59
        ELMASS(29) = 64
        ELMASS(30) = 65
        ELMASS(31) = 70
        ELMASS(32) = 73
        ELMASS(33) = 75
        ELMASS(34) = 79
        ELMASS(35) = 80
        ELMASS(36) =  0
        ELMASS(37) =  0
        ELMASS(38) =  0
        ELMASS(39) =  0
        ELMASS(40) =  0
        ELMASS(41) =  0
        ELMASS(42) =  0
        ELMASS(43) =  0
        ELMASS(44) =  0
        ELMASS(45) =  0
        ELMASS(46) =  0
        ELMASS(47) =  0
        ELMASS(48) =  0
        ELMASS(49) =  0
        ELMASS(50) =  0
        ELMASS(51) =  0
        ELMASS(52) =  0
        ELMASS(53) =  0
        ELMASS(54) =  0
        ELMASS(55) =  0
        ELMASS(56) =  0
        ELMASS(57) =  0
        ELMASS(58) =  0
        ELMASS(59) =  0
        ELMASS(60) =  0
        ELMASS(61) =  0
        ELMASS(62) =  0
        ELMASS(63) =  0
        ELMASS(64) =  0
        ELMASS(65) =  0
        ELMASS(66) =  0
        ELMASS(67) =  0
        ELMASS(68) =  0
        ELMASS(69) =  0
        ELMASS(70) =  0
        ELMASS(71) =  0
        ELMASS(72) =  0
        ELMASS(73) =  0
        ELMASS(74) =  0
        ELMASS(75) =  0
        ELMASS(76) =  0
        ELMASS(77) =  0
        ELMASS(78) =  0
        ELMASS(79) =  0
        ELMASS(80) =  0
        ELMASS(81) =  0
        ELMASS(82) =  0
        ELMASS(83) =  0
        ELMASS(84) =  0
        ELMASS(85) =  0
        ELMASS(86) =  0
        ELMASS(87) =  0
        ELMASS(88) =  0
        ELMASS(89) =  0
        ELMASS(90) =  0
        ELMASS(91) =  0
        ELMASS(92) =  0

        write(6,*) ' Global data :'
        do i=1,92
         if (elmass(i).ne.0.and.elempresent(i)) then
           write(6,*) ' Element No ',i,' = ',elsymb(i), &
                ' defined with mass',elmass(i)
         end if
        end do
        write(6,*)

END_PROVIDER
                     
        character*1 function lowercase(a)
          implicit none
          character*1 :: a
          lowercase=a
          if (a.eq.'A') lowercase='a'
          if (a.eq.'B') lowercase='b'
          if (a.eq.'C') lowercase='c'
          if (a.eq.'D') lowercase='d'
          if (a.eq.'E') lowercase='e'
          if (a.eq.'F') lowercase='f'
          if (a.eq.'G') lowercase='g'
          if (a.eq.'H') lowercase='h'
          if (a.eq.'I') lowercase='i'
          if (a.eq.'J') lowercase='j'
          if (a.eq.'K') lowercase='k'
          if (a.eq.'L') lowercase='l'
          if (a.eq.'M') lowercase='m'
          if (a.eq.'N') lowercase='n'
          if (a.eq.'O') lowercase='o'
          if (a.eq.'P') lowercase='p'
          if (a.eq.'Q') lowercase='q'
          if (a.eq.'R') lowercase='r'
          if (a.eq.'S') lowercase='s'
          if (a.eq.'T') lowercase='t'
          if (a.eq.'U') lowercase='u'
          if (a.eq.'V') lowercase='v'
          if (a.eq.'W') lowercase='w'
          if (a.eq.'X') lowercase='x'
          if (a.eq.'Y') lowercase='y'
          if (a.eq.'Z') lowercase='z'
        end function lowercase

        character*1 function uppercase(a)
          implicit none
          character*1 :: a
          uppercase=a
          if (a.eq.'a') uppercase='A'
          if (a.eq.'b') uppercase='B'
          if (a.eq.'c') uppercase='C'
          if (a.eq.'d') uppercase='D'
          if (a.eq.'e') uppercase='E'
          if (a.eq.'f') uppercase='F'
          if (a.eq.'g') uppercase='G'
          if (a.eq.'h') uppercase='H'
          if (a.eq.'i') uppercase='I'
          if (a.eq.'j') uppercase='J'
          if (a.eq.'k') uppercase='K'
          if (a.eq.'l') uppercase='L'
          if (a.eq.'m') uppercase='M'
          if (a.eq.'n') uppercase='N'
          if (a.eq.'o') uppercase='O'
          if (a.eq.'p') uppercase='P'
          if (a.eq.'q') uppercase='Q'
          if (a.eq.'r') uppercase='R'
          if (a.eq.'s') uppercase='S'
          if (a.eq.'t') uppercase='T'
          if (a.eq.'u') uppercase='U'
          if (a.eq.'v') uppercase='V'
          if (a.eq.'w') uppercase='W'
          if (a.eq.'x') uppercase='X'
          if (a.eq.'y') uppercase='Y'
          if (a.eq.'z') uppercase='Z'
        end function uppercase

        character*2 function ordername(a)
          implicit none
          character*2 :: a
          character*1 :: uppercase,lowercase
          ordername=uppercase(a(1:1))//lowercase(a(2:2))
        end function ordername


